fl

{

Propeller      MCD3204
     P10 ----  CS      
     P11 ----  CLK    
     P12 ----  Din        
     P13 ----  Dout       
         
Propeller      TouchScreen
     P18 ---- _Xl
     P19 ---- _Xr
     P20 ---- _Yu
     P21 ---- _Yd
                   
2015/11/24 15:31:37
}



\ MCP3204
d10 wconstant _cs
d11 wconstant _clk          
d12 wconstant _do               \ connect to MCP3204's Din         
d13 wconstant _di               \ connect to MCP3204's Dout
1 _di lshift constant _dim
\ TouchScreen 
d18 wconstant _Xl
d19 wconstant _Xr
d20 wconstant _Yu
d21 wconstant _Yd

\ ==================================================================
\ ADC
\ ================================================================== 
\ MCP3204
: _cs_l _cs pinlo ;
: _cs_h _cs pinhi ;
: _do_l _do pinlo ;
: _do_h _do pinhi ;
: _clk_l _clk pinlo ;
: _clk_h _clk pinhi ;

: _xr_out _Xr pinout ;
: _xl_out _Xl pinout ;
: _yu_out _Yu pinout ;
: _yd_out _Yd pinout ;
: _xr_in _Xr pinin ;
: _xl_in _Xl pinin ;
: _yu_in _Yu pinin ;
: _yd_in _Yd pinin ;
: _xl_h _Xl pinhi ;
: _yu_h _Yu pinhi ;
: _xl_l _Xl pinlo ;
: _yu_l _Yu pinlo ;


\ Convert analog[0-3.3V] to digital[0-4095] 
\ single-end input for MCP3204
\ ( n1 -- n2 )   n1:channel [0 - 3]  n2:data
: getA/D    
_cs_l
\ Output control-bits       
h18 or                        \ Add start-bit and single-bit
h10
5 0 do 
     2dup                     \ ( n1+h18 h10 n1+h18 h10 )      
     and 0> 
     if _do_h then
     _clk_h _clk_l 
     1 rshift 
     _do_l           
loop
2drop                                  
_clk_h _clk_l                 \ dummy clock

\ Read conversion-data   
0                             \ initial value
d13 0 do 
     1 lshift
     _clk_h  _clk_l
     ina COG@ _dim and 0> 
     if 1+ then       
loop     
1 rshift
_cs_h
;

\ Get average A/D
\ ( n1 -- n2 ) n1:ch  n2:value
: aveA/D 
0                             \ ( n1 0 )
d10 0 do over getA/D + loop   \ ( n1 sum )
d10 / nip                     \ ( sum/10 )
;


\ Set TouchScreen to non-measuring mode
\ ( -- )
: resetTS _Xl 4 0 do dup pinout 1+ loop drop ;

\ Get TouchScreen (x,y)position
\ ( -- )
: TS_xy
\ Set pins for ADC to output
_cs pinout _clk pinout _do pinout 
     
begin
     \ X position
     resetTS
     _xl_h                    \ Add 3V3 to X-axis resistor 
     _Yu pinin _Yd pinin      \ Set probe terminal to input  
     0 aveA/D d1800 - .       \ Get A/D value
     _xl_l                    \ Set X-axis resistor terminal to low
     
     \ Y position
     resetTS
     _yu_h                    \ Add 3V3 to Y-axis resistor 
     _Xl pinin _Xr pinin      \ Set probe terminal to input  
     1 aveA/D d1800 - .       \ Get A/D value
     _yu_l                    \ Set Y-axis resistor terminal to low
                          cr
     fkey? swap drop
until
;
     
\ Get Touch Pressure 
\ ( -- )
: getZ
\ Set pins for ADC to output
_cs pinout _clk pinout _do pinout 
     
begin
     \ X position
     resetTS
     _xl_h                    \ Add 3V3 to X-axis resistor 
     _Yu pinin _Yd pinin      \ Set probe terminal to input  
     0 aveA/D                 \ Get A/D value
     _xl_l                    \ Set X-axis resistor terminal to low
     
     \ Z1 position
     resetTS
     _yu_h                    \ Add 3V3 to _Yu and _Xr  
     _Xl pinin _Yd pinin      
     1 aveA/D                 \ Get _Xr A/D
     _yu_l                    
     
     \ Z2 position
     resetTS
     _yu_h                    \ Add 3V3 to _Yu and _Xr                    
     _Xl pinin _Yd pinin      
     2 aveA/D                 \ Get _Yd A/D
     _yu_l                    \ ( Xpos Z1 Z2 )
                     
     i>f swap i>f             \ ( Xpos float_Z2 float_Z1 )
     f/                       \ ( Xpos float_Z2/float_Z1 )
     1 i>f f-                 \ ( Xpos float((Z2/Z1) - 1) ) 
     swap i>f f*              \ ( float(Xpos * ((Z2/Z1) - 1)) )
     1 i>f swap f/            \ ( float(1/A )     A = Xpos * ((Z2/Z1) - 1)      
     d100000 i>f f*                       
     
     f>i spaces h2A emit cr 

                       d500 delms
     fkey? swap drop
until
;

\ Print X and Y with Threshold value
\ ( -- )
: demo
\ Set pins for ADC to output
_cs pinout _clk pinout _do pinout 
." Y    X" cr     
begin
     \ Y position
     resetTS
     _yu_h                    \ Add 3V3 to Y-axis resistor 
     _Xl pinin _Xr pinin      \ Set probe terminal to input  
     1 aveA/D                 \ Get A/D value
     _yu_l                    \ Set Y-axis resistor terminal to low

     \ X position
     resetTS
     _xl_h                    \ Add 3V3 to X-axis resistor 
     _Yu pinin _Yd pinin      \ Set probe terminal to input  
     0 aveA/D                 \ Get A/D value
     _xl_l                    \ Set X-axis resistor terminal to low
     dup
     
     \ Z1 position
     resetTS
     _yu_h                    \ Add 3V3 to _Yu and _Xr  
     _Xl pinin _Yd pinin      
     1 aveA/D                 \ Get _Xr A/D
     _yu_l                    
     
     \ Z2 position
     resetTS
     _yu_h                    \ Add 3V3 to _Yu and _Xr                    
     _Xl pinin _Yd pinin      
     2 aveA/D                 \ Get _Yd A/D
     _yu_l                    \ ( Xpos Z1 Z2 )
                     
     i>f swap i>f             \ ( Xpos float_Z2 float_Z1 )
     f/                       \ ( Xpos float_Z2/float_Z1 )
     1 i>f f-                 \ ( Xpos float((Z2/Z1) - 1) ) 
     swap i>f f*              \ ( float(Xpos * ((Z2/Z1) - 1)) )
     1 i>f swap f/            \ ( float(1/A )     A = Xpos * ((Z2/Z1) - 1)      
     d100000 i>f f*                       
     
     f>i 
     \ Compair TouchPresure and Threshold
     d20 >
     if
          . . cr
     else
          2drop
     then 

     fkey? swap drop
until
;
